799. Champagne Tower

Problem Statement

We stack glasses in a pyramid, where the first row has 1 glass, the second row has 2 glasses, and so on until the 100th row. Each glass holds one cup of champagne.

Then, some champagne is poured into the first glass at the top. When the topmost glass is full, any excess liquid poured will fall equally to the glass immediately to the left and right of it. When those glasses become full, any excess champagne will fall equally to the left and right of those glasses, and so on. (A glass at the bottom row has its excess champagne fall on the floor.)

For example, after one cup of champagne is poured, the top most glass is full. After two cups of champagne are poured, the two glasses on the second row are half full. After three cups of champagne are poured, those two cups become full - there are 3 full glasses total now. After four cups of champagne are poured, the third row has the middle glass half full, and the two outside glasses are a quarter full, as pictured below.

Now after pouring some non-negative integer cups of champagne, return how full the jth glass in the ith row is (both i and j are 0-indexed.)

Example 1:

Input: poured = 1, query_row = 1, query_glass = 1
Output: 0.00000
Explanation: We poured 1 cup of champange to the top glass of the tower (which is indexed as (0, 0)). There will be no excess liquid so all the glasses under the top glass will remain empty.

Example 2:

Input: poured = 2, query_row = 1, query_glass = 1
Output: 0.50000
Explanation: We poured 2 cups of champange to the top glass of the tower (which is indexed as (0, 0)). There is one cup of excess liquid. The glass indexed as (1, 0) and the glass indexed as (1, 1) will share the excess liquid equally, and each will get half cup of champange.

Example 3:

Input: poured = 100000009, query_row = 33, query_glass = 17
Output: 1.00000

Constraints:

  • 0 <= poured <= 109

  • 0 <= query_glass <= query_row < 100

Intuition

Approach:

We take 
00
10  11
20  21 22

At each stage, we take val from upper guy
like 21-> (10)-1/2
21 -> (11)-1/2

And add both
Because he gets half half from both

Now, 2 extra conditions
base condtion -> at 00 we return all glasses
2nd

let say at 00 we get infinite glasses poured
But query 11 will get infinite /2 , but max cap is 1

So we return minimum of both ans and 1

https://leetcode.com/problems/champagne-tower/description/?envType=daily-question&envId=2023-09-24

Approach 1:

C++
class Solution {
public:
    vector<vector<double>> dp;
    double find_ans(int poured, int row, int glass){
        if(row < 0 or glass < 0 or glass > row)
            return 0;
        if(row == 0 and glass == 0)
            return poured;
        if(dp[row][glass] != -1)
            return dp[row][glass];
        

        double left = (find_ans(poured, row-1, glass-1) - 1);
        if(left < 0)    left = 0;

        double right = (find_ans(poured, row-1, glass) - 1);
        if(right < 0)   right = 0;

        return dp[row][glass] = (left+right)/2;
    }

    double champagneTower(int poured, int query_row, int query_glass) {
        dp = vector<vector<double>>(101, vector<double>(101,-1));
        return min(1.00, find_ans(poured, query_row, query_glass));
    }
};

Approach 2:

C++

Approach 3:

C++

Approach 4:

C++

Similar Problems

Last updated